//////////////////////////////////////////
// FileList.h
// Copyright (c) 08/30/2022 by ECCSkelton
//////////////////////////////////////////
//BCCSkeltonのヘッダー−これに必要なヘッダーが入っている
#include	"ECCSkelton.h"
//リソースIDのヘッダー
#include	"ResFileList.h"

/////////////////////////////////////////////////////////////////////
//CMyWndクラスをCDLGクラスから派生させ、メッセージ用の関数を宣言する
/////////////////////////////////////////////////////////////////////
class CFILELIST : public CDLG
{
public:	//以下はコールバック関数マクロと関連している
	//２重起動防止用のMutex用ID名称
	CFILELIST(WCHAR* UName) : CDLG(UName) {}
	//ツールバー
	CTBAR m_TBar;
	//ステータスバー
	CSBAR m_SBar;
	//リストビュー
	CLISTVIEW m_ListView;
	//メニュー項目、ダイアログコントロール関連
	bool OnOpen();
	bool OnSave();
	bool OnExit();
	bool OnAdd();
	bool OnSearch();
	bool OnEdit();
	bool OnDelete();
	bool OnSort();
	bool OnVersion();
	//ウィンドウメッセージ関連
	CMDTABLE	//CMyWndクラスのOnCommand()関数宣言
	bool OnInit(WPARAM, LPARAM);
	bool OnNotify(WPARAM, LPARAM);
	bool OnSize(WPARAM, LPARAM);
	bool OnClose(WPARAM, LPARAM);
	bool OnDropFiles(WPARAM, LPARAM);
	bool OnMinMax(WPARAM, LPARAM);
	//ユーザー定義関数
	bool ChangeMenuStatus(bool);
	WCHAR* GetFileName(WCHAR*);
};

////////////////////////////////////////////////////////////////////////
//派生させたCFILTERLISTクラスのインスタンスとコールバック関数(マクロ）の作成
//主ウィンドウはダイアログと違い、コールバック関数は一つしか作れない
////////////////////////////////////////////////////////////////////////
CFILELIST FileList(L"FileList");	//ウィンドウクラスインスタンスの生成

//CFILELISTクラスのOnCommand()関数定義
BEGIN_CMDTABLE(CFILELIST)
	ON(IDM_OPEN, OnOpen())
	ON(IDM_SAVE, OnSave())
	ON(IDM_EXIT, OnExit())
	ON(IDM_ADD, OnAdd())
	ON(IDM_SEARCH, OnSearch())
	ON(IDM_EDIT, OnEdit())
	ON(IDM_DELETE, OnDelete())
	ON(IDM_SORT, OnSort())
	ON(IDM_VERSION, OnVersion())
END_CMDTABLE

///////////////////////////////////////////
// CDLGクラスからEDITDLGクラスを派生
// 複数の同一ダイアログ変数とダイアログも作
// れるが、一つのダイアログに一つの派生ダイ
// アログクラスを作成するのが基本
///////////////////////////////////////////
class EDITDLG : public CDLG {
public:
	//コントロール関連
	bool OnIdok();
	bool OnIdcancel();
	//ダイアログメッセージ関連
	CMDTABLE	//EDITDLGクラスのOnCommand()関数宣言
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// EDITDLGクラスダイアログ変数の生成とそのコールバック関数（マクロ）を定義
// 複数同一クラスのダイアログを作成することを予期してコールバック関数を明記
////////////////////////////////////////////////////////////////////////////
EDITDLG editdlg;

//EDITDLGクラスのOnCommand()関数定義
BEGIN_CMDTABLE(EDITDLG)
	ON(IDOK, OnIdok())
	ON(IDCANCEL, OnIdcancel())
END_CMDTABLE

///////////////////////////////////////////
// CDLGクラスからSEARCHDLGクラスを派生
// 複数の同一ダイアログ変数とダイアログも作
// れるが、一つのダイアログに一つの派生ダイ
// アログクラスを作成するのが基本
///////////////////////////////////////////
class SEARCHDLG : public CDLG {
public:
	WCHAR m_ToFind[MAX_PATH];
	//コントロール関連
	bool OnIdok();
	bool OnIdcancel();
	//ダイアログメッセージ関連
	CMDTABLE	//EDITDLGクラスのOnCommand()関数宣言
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// SEARCHDLGクラスダイアログ変数の生成とそのコールバック関数（マクロ）を定義
// 複数同一クラスのダイアログを作成することを予期してコールバック関数を明記
////////////////////////////////////////////////////////////////////////////
SEARCHDLG searchdlg;

//SEARCHDLGクラスのOnCommand()関数定義
BEGIN_CMDTABLE(SEARCHDLG)
	ON(IDOK, OnIdok())
	ON(IDCANCEL, OnIdcancel())
END_CMDTABLE

///////////////////////////////////////////
// CDLGクラスからSORTDLGクラスを派生
// 複数の同一ダイアログ変数とダイアログも作
// れるが、一つのダイアログに一つの派生ダイ
// アログクラスを作成するのが基本
///////////////////////////////////////////
class SORTDLG : public CDLG {
public:
	//コントロール関連
	bool OnIdok();
	bool OnIdcancel();
	//ダイアログメッセージ関連
	CMDTABLE	//EDITDLGクラスのOnCommand()関数宣言
	bool OnInit(WPARAM, LPARAM);
};

////////////////////////////////////////////////////////////////////////////
// SORTDLGクラスダイアログ変数の生成とそのコールバック関数（マクロ）を定義
// 複数同一クラスのダイアログを作成することを予期してコールバック関数を明記
////////////////////////////////////////////////////////////////////////////
SORTDLG sortdlg;

//SORTDLGクラスのOnCommand()関数定義
BEGIN_CMDTABLE(SORTDLG)
	ON(IDOK, OnIdok())
	ON(IDCANCEL, OnIdcancel())
END_CMDTABLE

///////////////////////////////////////////
// CDLGクラスからVERSIONDLGクラスを派生
// 複数の同一ダイアログ変数とダイアログも作
// れるが、一つのダイアログに一つの派生ダイ
// アログクラスを作成するのが基本
///////////////////////////////////////////
class VERSIONDLG : public CDLG {
public:
	//コントロール関連
	bool OnIdok();
	//ダイアログメッセージ関連
	CMDTABLE	//EDITDLGクラスのOnCommand()関数宣言
};

////////////////////////////////////////////////////////////////////////////
// VERSIONDLGクラスダイアログ変数の生成とそのコールバック関数（マクロ）を定義
// 複数同一クラスのダイアログを作成することを予期してコールバック関数を明記
////////////////////////////////////////////////////////////////////////////
VERSIONDLG versiondlg;

//VERSIONDLGクラスのOnCommand()関数定義
BEGIN_CMDTABLE(VERSIONDLG)
	ON(IDOK, OnIdok())
END_CMDTABLE
